"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var core_1 = require("../core");

var ClientState = function () {
    function ClientState() {
        var log = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

        _classCallCheck(this, ClientState);

        this.server = {};
        this.client = {};
        this.combined = {};
        this.diff = {};
        this.listeners = [];
        this.keyListeners = [];
        this.log = log;
    }

    _createClass(ClientState, [{
        key: "listen",
        value: function listen() {
            var listeners = arguments.length === 1 ? this.listeners : this.keyListeners;
            var listener = arguments.length === 1 ? arguments.length <= 0 ? undefined : arguments[0] : { keys: arguments.length <= 0 ? undefined : arguments[0], emit: arguments.length <= 1 ? undefined : arguments[1] };
            listeners.push(listener);
            return function () {
                return listeners.splice(listeners.indexOf(listener), 1);
            };
        }
    }, {
        key: "emitChanges",
        value: function emitChanges(changes, indices) {
            var _this = this;

            if (this.log) {
                console.log(_.cloneDeep({
                    server: this.server,
                    client: this.client,
                    combined: this.combined,
                    diff: this.diff
                }));
            }
            var changedTypes = Object.keys(changes);
            if (changedTypes.length > 0) {
                this.keyListeners.forEach(function (_ref) {
                    var keys = _ref.keys,
                        emit = _ref.emit;

                    if (keys.some(function (k) {
                        return _.get(changes, k);
                    })) {
                        emit(keys.map(function (k) {
                            return core_1.noUndef(_.get(_this.combined, k));
                        }));
                    }
                });
                var changedData = core_1.keysToObject(Object.keys(changes), function (type) {
                    return core_1.keysToObject(Object.keys(changes[type]), function (id) {
                        return core_1.keysToObject(Object.keys(changes[type][id]), function (field) {
                            return core_1.noUndef(_.get(_this.combined, [type, id, field]));
                        });
                    });
                });
                this.listeners.forEach(function (l) {
                    return l({ changes: changes, changedData: changedData, indices: indices });
                });
            }
        }
    }, {
        key: "set",
        value: function set(store, data, schema) {
            var changes = {};
            var setChanged = function setChanged(type, id, field) {
                changes[type] = changes[type] || {};
                changes[type][id] = changes[type][id] || {};
                changes[type][id][field] = true;
            };
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = Object.keys(data)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var type = _step.value;

                    if (data[type] === undefined) {
                        var _iteratorNormalCompletion2 = true;
                        var _didIteratorError2 = false;
                        var _iteratorError2 = undefined;

                        try {
                            for (var _iterator2 = Object.keys(this.client[type] || {})[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                                var id = _step2.value;
                                var _iteratorNormalCompletion3 = true;
                                var _didIteratorError3 = false;
                                var _iteratorError3 = undefined;

                                try {
                                    for (var _iterator3 = Object.keys(_.get(this.client, type, id) || {})[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                                        var field = _step3.value;

                                        if (core_1.noUndef(_.get(this.combined, [type, id, field])) !== core_1.noUndef(_.get(this.server, [type, id, field]))) {
                                            setChanged(type, id, field);
                                        }
                                    }
                                } catch (err) {
                                    _didIteratorError3 = true;
                                    _iteratorError3 = err;
                                } finally {
                                    try {
                                        if (!_iteratorNormalCompletion3 && _iterator3.return) {
                                            _iterator3.return();
                                        }
                                    } finally {
                                        if (_didIteratorError3) {
                                            throw _iteratorError3;
                                        }
                                    }
                                }
                            }
                        } catch (err) {
                            _didIteratorError2 = true;
                            _iteratorError2 = err;
                        } finally {
                            try {
                                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                    _iterator2.return();
                                }
                            } finally {
                                if (_didIteratorError2) {
                                    throw _iteratorError2;
                                }
                            }
                        }

                        delete this.client[type];
                        if (_.get(this.server, type)) {
                            this.combined[type] = _.cloneDeep(this.server[type]);
                        } else {
                            delete this.combined[type];
                        }
                        delete this.diff[type];
                    } else {
                        this[store][type] = this[store][type] || {};
                        this.combined[type] = this.combined[type] || {};
                        this.diff[type] = this.diff[type] || {};
                        var _iteratorNormalCompletion4 = true;
                        var _didIteratorError4 = false;
                        var _iteratorError4 = undefined;

                        try {
                            for (var _iterator4 = Object.keys(data[type])[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                                var _id = _step4.value;

                                if (data[type][_id] === undefined) {
                                    var _iteratorNormalCompletion5 = true;
                                    var _didIteratorError5 = false;
                                    var _iteratorError5 = undefined;

                                    try {
                                        for (var _iterator5 = Object.keys(_.get(this.client, type, _id) || {})[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                                            var _field = _step5.value;

                                            if (core_1.noUndef(_.get(this.combined, [type, _id, _field])) !== core_1.noUndef(_.get(this.server, [type, _id, _field]))) {
                                                setChanged(type, _id, _field);
                                            }
                                        }
                                    } catch (err) {
                                        _didIteratorError5 = true;
                                        _iteratorError5 = err;
                                    } finally {
                                        try {
                                            if (!_iteratorNormalCompletion5 && _iterator5.return) {
                                                _iterator5.return();
                                            }
                                        } finally {
                                            if (_didIteratorError5) {
                                                throw _iteratorError5;
                                            }
                                        }
                                    }

                                    delete this.client[type][_id];
                                    if (_.get(this.server, [type, _id])) {
                                        this.combined[type][_id] = _.cloneDeep(this.server[type][_id]);
                                    } else {
                                        delete this.combined[type][_id];
                                    }
                                    delete this.diff[type][_id];
                                } else if (data[type][_id] === null) {
                                    if (store === 'client') {
                                        var _iteratorNormalCompletion6 = true;
                                        var _didIteratorError6 = false;
                                        var _iteratorError6 = undefined;

                                        try {
                                            for (var _iterator6 = Object.keys(this.combined[type][_id] || {})[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
                                                var _field2 = _step6.value;

                                                if (_.get(this.combined, [type, _id])) {
                                                    setChanged(type, _id, _field2);
                                                }
                                            }
                                        } catch (err) {
                                            _didIteratorError6 = true;
                                            _iteratorError6 = err;
                                        } finally {
                                            try {
                                                if (!_iteratorNormalCompletion6 && _iterator6.return) {
                                                    _iterator6.return();
                                                }
                                            } finally {
                                                if (_didIteratorError6) {
                                                    throw _iteratorError6;
                                                }
                                            }
                                        }

                                        this.client[type][_id] = null;
                                        delete this.combined[type][_id];
                                        this.diff[type][_id] = -1;
                                    } else {
                                        var _iteratorNormalCompletion7 = true;
                                        var _didIteratorError7 = false;
                                        var _iteratorError7 = undefined;

                                        try {
                                            for (var _iterator7 = Object.keys(this.combined[type][_id] || {})[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                                                var _field3 = _step7.value;

                                                if (core_1.noUndef(_.get(this.combined, [type, _id, _field3])) !== core_1.noUndef(_.get(this.client, [type, _id, _field3]))) {
                                                    setChanged(type, _id, _field3);
                                                }
                                            }
                                        } catch (err) {
                                            _didIteratorError7 = true;
                                            _iteratorError7 = err;
                                        } finally {
                                            try {
                                                if (!_iteratorNormalCompletion7 && _iterator7.return) {
                                                    _iterator7.return();
                                                }
                                            } finally {
                                                if (_didIteratorError7) {
                                                    throw _iteratorError7;
                                                }
                                            }
                                        }

                                        delete this.server[type][_id];
                                        if (_.get(this.client, [type, _id])) {
                                            this.combined[type][_id] = _.cloneDeep(this.client[type][_id]);
                                            this.diff[type][_id] = 1;
                                        } else {
                                            delete this.combined[type][_id];
                                        }
                                    }
                                } else {
                                    this[store][type][_id] = this[store][type][_id] || {};
                                    if (_.get(this.client, [type, _id]) !== null) {
                                        this.combined[type][_id] = this.combined[type][_id] || {};
                                    }
                                    var _iteratorNormalCompletion8 = true;
                                    var _didIteratorError8 = false;
                                    var _iteratorError8 = undefined;

                                    try {
                                        for (var _iterator8 = Object.keys(data[type][_id])[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
                                            var _field4 = _step8.value;

                                            var prev = core_1.noUndef(_.get(this.combined, [type, _id, _field4]));
                                            if (store === 'client') {
                                                if (data[type][_id][_field4] === undefined) {
                                                    delete this.client[type][_id][_field4];
                                                    if (core_1.noUndef(_.get(this.server, [type, _id, _field4])) !== null) {
                                                        this.combined[type][_id][_field4] = this.server[type][_id][_field4];
                                                    } else {
                                                        delete this.combined[type][_id][_field4];
                                                    }
                                                } else {
                                                    this.client[type][_id][_field4] = data[type][_id][_field4];
                                                    this.combined[type][_id][_field4] = data[type][_id][_field4];
                                                }
                                            } else {
                                                var f = schema[type][_field4];
                                                var decode = core_1.fieldIs.scalar(f) && core_1.scalars[f.scalar].decode;
                                                var fieldValue = data[type][_id][_field4] === null || !decode ? data[type][_id][_field4] : core_1.mapArray(data[type][_id][_field4], decode);
                                                if (core_1.fieldIs.relation(f) && f.isList && typeof (fieldValue && fieldValue[0]) === 'number') {
                                                    fieldValue.unshift.apply(fieldValue, _toConsumableArray(new Array(fieldValue.shift())));
                                                }
                                                if (_.get(this.client, [type, _id]) !== null && _.get(this.client, [type, _id, _field4]) === undefined) {
                                                    this.combined[type][_id][_field4] = fieldValue;
                                                }
                                                this.server[type][_id][_field4] = fieldValue;
                                            }
                                            if (core_1.noUndef(_.get(this.combined, [type, _id, _field4])) !== prev) {
                                                setChanged(type, _id, _field4);
                                            }
                                        }
                                    } catch (err) {
                                        _didIteratorError8 = true;
                                        _iteratorError8 = err;
                                    } finally {
                                        try {
                                            if (!_iteratorNormalCompletion8 && _iterator8.return) {
                                                _iterator8.return();
                                            }
                                        } finally {
                                            if (_didIteratorError8) {
                                                throw _iteratorError8;
                                            }
                                        }
                                    }

                                    if (_.get(this.client, [type, _id]) && Object.keys(_.get(this.client, [type, _id])).length === 0) {
                                        delete this.client[type][_id];
                                        delete this.diff[type][_id];
                                    }
                                    if (_.get(this.combined, [type, _id]) && Object.keys(_.get(this.combined, [type, _id])).length === 0) {
                                        delete this.combined[type][_id];
                                    }
                                    if (_.get(changes, [type, _id]) && _.get(this.client, [type, _id])) {
                                        this.diff[type][_id] = this.server[type] && this.server[type][_id] ? 0 : 1;
                                    }
                                }
                            }
                        } catch (err) {
                            _didIteratorError4 = true;
                            _iteratorError4 = err;
                        } finally {
                            try {
                                if (!_iteratorNormalCompletion4 && _iterator4.return) {
                                    _iterator4.return();
                                }
                            } finally {
                                if (_didIteratorError4) {
                                    throw _iteratorError4;
                                }
                            }
                        }
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return changes;
        }
    }, {
        key: "setClient",
        value: function setClient(values) {
            this.emitChanges(this.set('client', values.reduce(function (res, v) {
                return _.set(res, v.key, v.value);
            }, {})));
        }
    }, {
        key: "setServer",
        value: function setServer(data, schema, indices) {
            this.emitChanges(this.set('server', data, schema), indices);
        }
    }]);

    return ClientState;
}();

exports.default = ClientState;