"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var graphql_1 = require("graphql");
var core_1 = require("../core");
var ClientState_1 = require("./ClientState");
var queryLayers_1 = require("./queryLayers");
var readLayer_1 = require("./readLayer");
var ops = { $ne: '!=', $lte: '<=', $gte: '>=', $eq: '=', $lt: '<', $gt: '>' };
var printFilter = function printFilter(filter) {
    var key = Object.keys(filter)[0];
    if (!key) return '';
    if (key === '$and') return "(" + filter[key].map(printFilter).join(', ') + ")";
    if (key === '$or') return "(" + filter[key].map(printFilter).join(' | ') + ")";
    var op = Object.keys(filter[key])[0];
    return "" + key + ops[op] + filter[key][op];
};
function buildClient(url, authRefresh, log) {
    var _this = this;

    var _schema = void 0;
    var _auth = authRefresh ? {
        refresh: authRefresh,
        state: JSON.parse(typeof localStorage !== 'undefined' && localStorage.getItem('kalamboAuth') || 'null')
    } : null;
    var state = new ClientState_1.default(log);
    var newIds = {};
    var watchers = [];
    var fields = {
        active: {},
        next: {}
    };
    var queries = {};
    var commits = [];
    var currentRun = -1;
    var doFetch = function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(body) {
            var response;
            return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            _context.next = 2;
                            return fetch(url, {
                                method: 'POST',
                                headers: Object.assign({ 'Content-Type': 'application/json' }, _auth && _auth.state ? { Authorization: "Bearer " + _auth.state.token } : {}),
                                body: JSON.stringify(body)
                            });

                        case 2:
                            response = _context.sent;

                            if (response.ok) {
                                _context.next = 5;
                                break;
                            }

                            throw new Error();

                        case 5:
                            _context.next = 7;
                            return response.json();

                        case 7:
                            return _context.abrupt("return", _context.sent);

                        case 8:
                        case "end":
                            return _context.stop();
                    }
                }
            }, _callee, _this);
        }));

        return function doFetch(_x) {
            return _ref.apply(this, arguments);
        };
    }();
    var run = _.throttle(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var runIndex, requests, _loop, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, type, queryIndices, firstIndicies, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, i, commitIndices, _loop2, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, _ref3, values, commitWatchers, responses, refreshed, newTokens, _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, _i;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        if (!_schema) {
                            _context2.next = 110;
                            break;
                        }

                        runIndex = ++currentRun;
                        requests = [];

                        _loop = function _loop(type) {
                            var _iteratorNormalCompletion5 = true;
                            var _didIteratorError5 = false;
                            var _iteratorError5 = undefined;

                            try {
                                for (var _iterator5 = Object.keys(fields.next[type])[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                                    var id = _step5.value;

                                    requests.push({
                                        query: "{\n                " + type + "(filter: [\"id\", \"=\", \"" + id + "\"]) {\n                  id\n                  " + Object.keys(fields.next[type][id]).map(function (f) {
                                            return core_1.fieldIs.scalar(_schema[type][f]) ? f : f + " { id }";
                                        }).join('\n') + "\n                }\n              }",
                                        normalize: true
                                    });
                                }
                            } catch (err) {
                                _didIteratorError5 = true;
                                _iteratorError5 = err;
                            } finally {
                                try {
                                    if (!_iteratorNormalCompletion5 && _iterator5.return) {
                                        _iterator5.return();
                                    }
                                } finally {
                                    if (_didIteratorError5) {
                                        throw _iteratorError5;
                                    }
                                }
                            }
                        };

                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        _context2.prev = 7;

                        for (_iterator = Object.keys(fields.next)[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                            type = _step.value;

                            _loop(type);
                        }
                        _context2.next = 15;
                        break;

                    case 11:
                        _context2.prev = 11;
                        _context2.t0 = _context2["catch"](7);
                        _didIteratorError = true;
                        _iteratorError = _context2.t0;

                    case 15:
                        _context2.prev = 15;
                        _context2.prev = 16;

                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }

                    case 18:
                        _context2.prev = 18;

                        if (!_didIteratorError) {
                            _context2.next = 21;
                            break;
                        }

                        throw _iteratorError;

                    case 21:
                        return _context2.finish(18);

                    case 22:
                        return _context2.finish(15);

                    case 23:
                        fields.next = {};
                        queryIndices = Object.keys(queries).filter(function (k) {
                            return queries[k].next;
                        }).map(function (k) {
                            return parseInt(k, 10);
                        });
                        firstIndicies = {};
                        _iteratorNormalCompletion2 = true;
                        _didIteratorError2 = false;
                        _iteratorError2 = undefined;
                        _context2.prev = 29;

                        for (_iterator2 = queryIndices[Symbol.iterator](); !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                            i = _step2.value;

                            firstIndicies[i] = requests.length;
                            requests.push.apply(requests, _toConsumableArray(queries[i].next.queries.map(function (query) {
                                return {
                                    query: query,
                                    normalize: true
                                };
                            })));
                            queries[i].prev = {
                                ids: queries[i].next.ids,
                                slice: queries[i].next.slice
                            };
                            delete queries[i].next;
                        }
                        _context2.next = 37;
                        break;

                    case 33:
                        _context2.prev = 33;
                        _context2.t1 = _context2["catch"](29);
                        _didIteratorError2 = true;
                        _iteratorError2 = _context2.t1;

                    case 37:
                        _context2.prev = 37;
                        _context2.prev = 38;

                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                            _iterator2.return();
                        }

                    case 40:
                        _context2.prev = 40;

                        if (!_didIteratorError2) {
                            _context2.next = 43;
                            break;
                        }

                        throw _iteratorError2;

                    case 43:
                        return _context2.finish(40);

                    case 44:
                        return _context2.finish(37);

                    case 45:
                        commitIndices = [];

                        _loop2 = function _loop2(values) {
                            var data = values.reduce(function (res, _ref4) {
                                var key = _ref4.key,
                                    value = _ref4.value;

                                var field = _schema[key[0]][key[2]];
                                var encode = core_1.fieldIs.scalar(field) && core_1.scalars[field.scalar].encode;
                                return _.set(res, key, value === null || !encode ? value : core_1.mapArray(value, encode));
                            }, {});
                            var types = Object.keys(data);
                            var dataArrays = core_1.keysToObject(types, function (type) {
                                return Object.keys(data[type]).map(function (id) {
                                    return Object.assign({ id: id }, data[type][id]);
                                });
                            });
                            commitIndices.push(requests.length);
                            requests.push({
                                query: "\n              mutation Mutate(" + types.map(function (t) {
                                    return "$" + t + ": [" + t + "Input!]";
                                }).join(', ') + ") {\n                commit(" + types.map(function (t) {
                                    return t + ": $" + t;
                                }).join(', ') + ") {\n                  " + types.map(function (t) {
                                    return t + " {\n                        " + Array.from(new Set([].concat(_toConsumableArray(dataArrays[t].reduce(function (res, o) {
                                        return [].concat(_toConsumableArray(res), _toConsumableArray(Object.keys(o)));
                                    }, [])), ['createdat', 'modifiedat']))).map(function (f) {
                                        return core_1.fieldIs.scalar(_schema[t][f]) ? f : f + " { id }";
                                    }).join('\n') + "\n                      }";
                                }).join('\n') + "\n                }\n              }\n            ",
                                variables: dataArrays,
                                normalize: true
                            });
                        };

                        _iteratorNormalCompletion3 = true;
                        _didIteratorError3 = false;
                        _iteratorError3 = undefined;
                        _context2.prev = 50;

                        for (_iterator3 = commits[Symbol.iterator](); !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                            _ref3 = _step3.value;
                            values = _ref3.values;

                            _loop2(values);
                        }
                        _context2.next = 58;
                        break;

                    case 54:
                        _context2.prev = 54;
                        _context2.t2 = _context2["catch"](50);
                        _didIteratorError3 = true;
                        _iteratorError3 = _context2.t2;

                    case 58:
                        _context2.prev = 58;
                        _context2.prev = 59;

                        if (!_iteratorNormalCompletion3 && _iterator3.return) {
                            _iterator3.return();
                        }

                    case 61:
                        _context2.prev = 61;

                        if (!_didIteratorError3) {
                            _context2.next = 64;
                            break;
                        }

                        throw _iteratorError3;

                    case 64:
                        return _context2.finish(61);

                    case 65:
                        return _context2.finish(58);

                    case 66:
                        commitWatchers = commits.map(function (c) {
                            return c.watcher;
                        });

                        commits = [];

                        if (!(requests.length > 0)) {
                            _context2.next = 109;
                            break;
                        }

                        responses = void 0;
                        _context2.prev = 70;
                        _context2.next = 73;
                        return doFetch(requests);

                    case 73:
                        responses = _context2.sent;
                        _context2.next = 88;
                        break;

                    case 76:
                        _context2.prev = 76;
                        _context2.t3 = _context2["catch"](70);
                        refreshed = false;

                        if (!(_auth && _auth.refresh && _auth.state && _auth.state.refresh)) {
                            _context2.next = 84;
                            break;
                        }

                        _context2.next = 82;
                        return _auth.refresh(_auth.state.refresh);

                    case 82:
                        newTokens = _context2.sent;

                        if (newTokens) {
                            setAuth(Object.assign({}, _auth.state, newTokens));
                            refreshed = true;
                        }

                    case 84:
                        if (_auth && !refreshed) setAuth(null);
                        _context2.next = 87;
                        return doFetch(requests);

                    case 87:
                        responses = _context2.sent;

                    case 88:
                        state.setServer(responses[0].data, _schema, queryIndices);
                        _iteratorNormalCompletion4 = true;
                        _didIteratorError4 = false;
                        _iteratorError4 = undefined;
                        _context2.prev = 92;
                        for (_iterator4 = queryIndices[Symbol.iterator](); !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                            _i = _step4.value;

                            queries[_i].firstIds = responses[firstIndicies[_i]].firstIds;
                        }
                        _context2.next = 100;
                        break;

                    case 96:
                        _context2.prev = 96;
                        _context2.t4 = _context2["catch"](92);
                        _didIteratorError4 = true;
                        _iteratorError4 = _context2.t4;

                    case 100:
                        _context2.prev = 100;
                        _context2.prev = 101;

                        if (!_iteratorNormalCompletion4 && _iterator4.return) {
                            _iterator4.return();
                        }

                    case 103:
                        _context2.prev = 103;

                        if (!_didIteratorError4) {
                            _context2.next = 106;
                            break;
                        }

                        throw _iteratorError4;

                    case 106:
                        return _context2.finish(103);

                    case 107:
                        return _context2.finish(100);

                    case 108:
                        commitWatchers.forEach(function (watcher, i) {
                            var _responses$commitIndi = responses[commitIndices[i]],
                                newIds = _responses$commitIndi.newIds,
                                errors = _responses$commitIndi.errors;

                            watcher({ newIds: newIds, errors: errors });
                        });

                    case 109:
                        if (currentRun === runIndex) {
                            watchers.forEach(function (w) {
                                return w(true, queryIndices);
                            });
                        }

                    case 110:
                    case "end":
                        return _context2.stop();
                }
            }
        }, _callee2, _this, [[7, 11, 15, 23], [16,, 18, 22], [29, 33, 37, 45], [38,, 40, 44], [50, 54, 58, 66], [59,, 61, 65], [70, 76], [92, 96, 100, 108], [101,, 103, 107]]);
    })), 100);
    var setAuth = function setAuth(authState) {
        if (_auth) {
            var reset = (_auth.state && _auth.state.id) !== (authState && authState.id);
            if (!authState) localStorage.removeItem('kalamboAuth');else localStorage.setItem('kalamboAuth', JSON.stringify(authState));
            _auth.state = authState;
            if (reset) {
                watchers.forEach(function (w) {
                    return w(false);
                });
                state.setServer(core_1.keysToObject(Object.keys(state.server), function (type) {
                    return core_1.keysToObject(Object.keys(state.server[type]), function () {
                        return null;
                    });
                }), _schema, []);
                fields.next = {};
                var _iteratorNormalCompletion6 = true;
                var _didIteratorError6 = false;
                var _iteratorError6 = undefined;

                try {
                    for (var _iterator6 = Object.keys(fields.active)[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
                        var type = _step6.value;
                        var _iteratorNormalCompletion7 = true;
                        var _didIteratorError7 = false;
                        var _iteratorError7 = undefined;

                        try {
                            for (var _iterator7 = Object.keys(fields.active[type])[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                                var id = _step7.value;
                                var _iteratorNormalCompletion8 = true;
                                var _didIteratorError8 = false;
                                var _iteratorError8 = undefined;

                                try {
                                    for (var _iterator8 = Object.keys(fields.active[type][id])[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
                                        var field = _step8.value;

                                        if (fields.active[type][id][field]) {
                                            _.set(fields.next, [type, id, field], true);
                                        }
                                    }
                                } catch (err) {
                                    _didIteratorError8 = true;
                                    _iteratorError8 = err;
                                } finally {
                                    try {
                                        if (!_iteratorNormalCompletion8 && _iterator8.return) {
                                            _iterator8.return();
                                        }
                                    } finally {
                                        if (_didIteratorError8) {
                                            throw _iteratorError8;
                                        }
                                    }
                                }
                            }
                        } catch (err) {
                            _didIteratorError7 = true;
                            _iteratorError7 = err;
                        } finally {
                            try {
                                if (!_iteratorNormalCompletion7 && _iterator7.return) {
                                    _iterator7.return();
                                }
                            } finally {
                                if (_didIteratorError7) {
                                    throw _iteratorError7;
                                }
                            }
                        }
                    }
                } catch (err) {
                    _didIteratorError6 = true;
                    _iteratorError6 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion6 && _iterator6.return) {
                            _iterator6.return();
                        }
                    } finally {
                        if (_didIteratorError6) {
                            throw _iteratorError6;
                        }
                    }
                }

                Object.keys(queries).forEach(function (k) {
                    return queries[k] = {};
                });
                run();
            }
        }
    };
    _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var schemaFields, _iteratorNormalCompletion9, _didIteratorError9, _iteratorError9, _iterator9, _step9, type, _iteratorNormalCompletion10, _didIteratorError10, _iteratorError10, _iterator10, _step10, field;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        _context3.t0 = graphql_1;
                        _context3.next = 3;
                        return fetch(url, {
                            method: 'POST',
                            headers: { 'Content-Type': 'application/json' },
                            body: JSON.stringify({ query: graphql_1.introspectionQuery })
                        });

                    case 3:
                        _context3.next = 5;
                        return _context3.sent.json();

                    case 5:
                        _context3.t1 = _context3.sent.data;
                        schemaFields = _context3.t0.buildClientSchema.call(_context3.t0, _context3.t1).getQueryType().getFields();

                        _schema = core_1.keysToObject(Object.keys(schemaFields), function (type) {
                            var fields = schemaFields[type].type.ofType.ofType.getFields();
                            return core_1.keysToObject(Object.keys(fields), function (field) {
                                return JSON.parse(fields[field].description);
                            });
                        });

                        if (!_auth) {
                            _context3.next = 52;
                            break;
                        }

                        _iteratorNormalCompletion9 = true;
                        _didIteratorError9 = false;
                        _iteratorError9 = undefined;
                        _context3.prev = 12;
                        _iterator9 = Object.keys(_schema)[Symbol.iterator]();

                    case 14:
                        if (_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done) {
                            _context3.next = 38;
                            break;
                        }

                        type = _step9.value;
                        _iteratorNormalCompletion10 = true;
                        _didIteratorError10 = false;
                        _iteratorError10 = undefined;
                        _context3.prev = 19;

                        for (_iterator10 = Object.keys(_schema[type])[Symbol.iterator](); !(_iteratorNormalCompletion10 = (_step10 = _iterator10.next()).done); _iteratorNormalCompletion10 = true) {
                            field = _step10.value;

                            if (_schema[type][field].scalar === 'auth') {
                                _auth.field = { type: type, field: field };
                                _schema[type][field].scalar = 'string';
                                _schema[type].password = { scalar: 'string' };
                            }
                        }
                        _context3.next = 27;
                        break;

                    case 23:
                        _context3.prev = 23;
                        _context3.t2 = _context3["catch"](19);
                        _didIteratorError10 = true;
                        _iteratorError10 = _context3.t2;

                    case 27:
                        _context3.prev = 27;
                        _context3.prev = 28;

                        if (!_iteratorNormalCompletion10 && _iterator10.return) {
                            _iterator10.return();
                        }

                    case 30:
                        _context3.prev = 30;

                        if (!_didIteratorError10) {
                            _context3.next = 33;
                            break;
                        }

                        throw _iteratorError10;

                    case 33:
                        return _context3.finish(30);

                    case 34:
                        return _context3.finish(27);

                    case 35:
                        _iteratorNormalCompletion9 = true;
                        _context3.next = 14;
                        break;

                    case 38:
                        _context3.next = 44;
                        break;

                    case 40:
                        _context3.prev = 40;
                        _context3.t3 = _context3["catch"](12);
                        _didIteratorError9 = true;
                        _iteratorError9 = _context3.t3;

                    case 44:
                        _context3.prev = 44;
                        _context3.prev = 45;

                        if (!_iteratorNormalCompletion9 && _iterator9.return) {
                            _iterator9.return();
                        }

                    case 47:
                        _context3.prev = 47;

                        if (!_didIteratorError9) {
                            _context3.next = 50;
                            break;
                        }

                        throw _iteratorError9;

                    case 50:
                        return _context3.finish(47);

                    case 51:
                        return _context3.finish(44);

                    case 52:
                        run();

                    case 53:
                    case "end":
                        return _context3.stop();
                }
            }
        }, _callee3, _this, [[12, 40, 44, 52], [19, 23, 27, 35], [28,, 30, 34], [45,, 47, 51]]);
    }))();
    return {
        schema: function schema() {
            return _schema;
        },
        newId: function newId(type) {
            newIds[type] = newIds[type] || 0;
            return "$" + newIds[type]++;
        },
        auth: function auth(authState) {
            var token = _auth && _auth.state && _auth.state.token;
            setAuth(authState || null);
            return token;
        },
        get: function get() {
            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            var _args4 = _slicedToArray(args, 2),
                keys = _args4[0],
                listener = _args4[1];

            return core_1.promisifyEmitter(function (innerListener) {
                if (keys.length === 0) {
                    innerListener([]);
                    return function () {};
                }
                var ready = void 0;
                var unlisten = void 0;
                var watcher = function watcher(newReady) {
                    if (newReady !== ready) {
                        ready = newReady;
                        if (ready) {
                            innerListener(keys.map(function (k) {
                                return core_1.noUndef(_.get(state.combined, k));
                            }));
                            unlisten = state.listen(keys, innerListener);
                        } else {
                            innerListener(null);
                            if (unlisten) unlisten();
                        }
                    }
                };
                watchers.push(watcher);
                var alreadyFetched = true;
                var serverKeys = keys.filter(function (_ref6) {
                    var _ref7 = _slicedToArray(_ref6, 2),
                        _ = _ref7[0],
                        id = _ref7[1];

                    return id[0] !== '$';
                });
                var _iteratorNormalCompletion11 = true;
                var _didIteratorError11 = false;
                var _iteratorError11 = undefined;

                try {
                    for (var _iterator11 = serverKeys[Symbol.iterator](), _step11; !(_iteratorNormalCompletion11 = (_step11 = _iterator11.next()).done); _iteratorNormalCompletion11 = true) {
                        var key = _step11.value;

                        _.set(fields.active, key, (_.get(fields.active, key) || 0) + 1);
                        if (_.get(state.server, key) === undefined) {
                            alreadyFetched = false;
                            _.set(fields.next, key, true);
                        }
                    }
                } catch (err) {
                    _didIteratorError11 = true;
                    _iteratorError11 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion11 && _iterator11.return) {
                            _iterator11.return();
                        }
                    } finally {
                        if (_didIteratorError11) {
                            throw _iteratorError11;
                        }
                    }
                }

                watcher(alreadyFetched);
                if (!alreadyFetched) run();
                return function () {
                    watchers.splice(watchers.indexOf(watcher), 1);
                    var _iteratorNormalCompletion12 = true;
                    var _didIteratorError12 = false;
                    var _iteratorError12 = undefined;

                    try {
                        for (var _iterator12 = serverKeys[Symbol.iterator](), _step12; !(_iteratorNormalCompletion12 = (_step12 = _iterator12.next()).done); _iteratorNormalCompletion12 = true) {
                            var _key2 = _step12.value;

                            fields.active[_key2[0]][_key2[1]][_key2[2]]--;
                        }
                    } catch (err) {
                        _didIteratorError12 = true;
                        _iteratorError12 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion12 && _iterator12.return) {
                                _iterator12.return();
                            }
                        } finally {
                            if (_didIteratorError12) {
                                throw _iteratorError12;
                            }
                        }
                    }

                    if (unlisten) unlisten();
                };
            }, listener);
        },
        query: function query() {
            for (var _len2 = arguments.length, args = Array(_len2), _key3 = 0; _key3 < _len2; _key3++) {
                args[_key3] = arguments[_key3];
            }

            var queryDoc = graphql_1.parse(args[0]);

            var _ref8 = args.length === 3 ? [undefined].concat(_toConsumableArray(args.slice(1))) : args.slice(1),
                _ref9 = _slicedToArray(_ref8, 3),
                withInfo = _ref9[0],
                onLoad = _ref9[1],
                onChange = _ref9[2];

            return core_1.promisifyEmitter(function (innerListener) {
                var queryIndex = Math.max.apply(Math, _toConsumableArray(Object.keys(queries).map(function (k) {
                    return parseInt(k, 10);
                })).concat([-1])) + 1;
                queries[queryIndex] = {};
                var layers = null;
                var rootUpdaters = null;
                var data = {};
                var spans = {};
                var checkRun = function checkRun() {
                    layers = layers || queryLayers_1.default(_schema, queryDoc, _auth && _auth.state && _auth.state.id, withInfo);
                    queries[queryIndex].next = {
                        ids: {},
                        slice: {},
                        queries: []
                    };
                    var alreadyFetched = true;
                    var processLayer = function processLayer(_ref10) {
                        var root = _ref10.root,
                            field = _ref10.field,
                            args = _ref10.args,
                            structuralFields = _ref10.structuralFields,
                            scalarFields = _ref10.scalarFields,
                            relations = _ref10.relations,
                            path = _ref10.path,
                            getArgsState = _ref10.getArgsState;

                        var fields = Array.from(new Set(['id'].concat(_toConsumableArray(Object.keys(scalarFields)), _toConsumableArray(structuralFields))));
                        var inner = "{\n              " + fields.join('\n') + "\n              " + relations.map(processLayer).join('\n') + "\n            }";
                        if (core_1.fieldIs.foreignRelation(field) || field.isList) {
                            var _getArgsState = getArgsState(state),
                                extra = _getArgsState.extra,
                                ids = _getArgsState.ids;

                            var prev = queries[queryIndex].prev || {
                                ids: {},
                                slice: {}
                            };
                            var _newIds = prev.ids[path] ? ids.filter(function (id) {
                                return !prev.ids[path].includes(id);
                            }) : ids;
                            queries[queryIndex].next.ids[path] = ids;
                            if (_newIds.length > 0) {
                                queries[queryIndex].next.queries.push("{\n                  " + root.field + "(filter: [\"id\", \"in\", " + JSON.stringify(_newIds) + "]) " + inner + "\n                }");
                            }
                            if (!prev.slice[path] || (args.start || 0) - extra.start < prev.slice[path].start || prev.slice[path].end !== undefined && (args.end === undefined || args.end + extra.end > prev.slice[path].end)) {
                                alreadyFetched = false;
                            }
                            var fullArgs = Object.assign({}, args, { start: (args.start || 0) - extra.start, end: core_1.undefOr(args.end, args.end + extra.end), offset: extra.start, trace: prev.slice[path] });
                            var printedArgs = Object.keys(fullArgs).filter(function (k) {
                                return fullArgs[k] !== undefined;
                            }).map(function (k) {
                                return k + ": " + JSON.stringify(fullArgs[k]).replace(/\"([^(\")"]+)\":/g, '$1:');
                            });
                            queries[queryIndex].next.slice[path] = {
                                start: (args.start || 0) - extra.start,
                                end: core_1.undefOr(args.end, args.end + extra.end)
                            };
                            return root.field + "(" + printedArgs + ") " + inner;
                        }
                        return root.field + " " + inner;
                    };
                    var baseQuery = "{\n            " + layers.map(processLayer).join('\n') + "\n          }";
                    if (!alreadyFetched) {
                        queries[queryIndex].next.queries.unshift(baseQuery);
                    }
                    if (queries[queryIndex].next.queries.length > 0) {
                        innerListener(null);
                        rootUpdaters = null;
                        run();
                    } else {
                        delete queries[queryIndex].next;
                        data = {};
                        spans = {};
                        rootUpdaters = layers.map(function (layer) {
                            return readLayer_1.default(layer, { '': data }, state, queries[queryIndex].firstIds, withInfo && { '': spans });
                        });
                        if (withInfo) {
                            spans[''] = Math.max.apply(Math, _toConsumableArray(layers.map(function (_ref11) {
                                var root = _ref11.root;
                                return spans[root.field].reduce(function (res, v) {
                                    return res + v[''];
                                }, 0);
                            })).concat([1]));
                        }
                        innerListener(withInfo ? { data: data, spans: spans } : data);
                    }
                };
                var unlisten = void 0;
                var watcher = function watcher(ready) {
                    var indices = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

                    if (ready) {
                        if (!layers || indices.includes(queryIndex)) checkRun();
                        // if no listener for query then above checkRun() can lead to
                        // immediate stop of this query, so need to check still running
                        if (queries[queryIndex]) {
                            unlisten = unlisten || state.listen(function (_ref12) {
                                var changes = _ref12.changes,
                                    changedData = _ref12.changedData,
                                    indices = _ref12.indices;

                                if (!indices || !indices.includes(queryIndex)) {
                                    var updateType = rootUpdaters ? Math.max.apply(Math, _toConsumableArray(rootUpdaters.map(function (updater) {
                                        return updater(changes, onChange === true);
                                    }))) : 2;
                                    if (updateType === 2) {
                                        checkRun();
                                    } else if (updateType === 1) {
                                        if (onChange === true) innerListener(data);else onChange(changedData);
                                    }
                                }
                            });
                        }
                    } else {
                        innerListener(null);
                        layers = null;
                        rootUpdaters = null;
                        if (unlisten) unlisten();
                    }
                };
                watchers.push(watcher);
                if (_schema) checkRun();
                return function () {
                    delete queries[queryIndex];
                    watchers.splice(watchers.indexOf(watcher), 1);
                    if (unlisten) unlisten();
                };
            }, onLoad);
        },
        set: function set(values) {
            if (values.length !== 0) state.setClient(values);
        },
        commit: function () {
            var _ref13 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(keys) {
                var _this2 = this;

                return regeneratorRuntime.wrap(function _callee5$(_context5) {
                    while (1) {
                        switch (_context5.prev = _context5.next) {
                            case 0:
                                return _context5.abrupt("return", new Promise(function (resolve) {
                                    if (keys.length === 0) {
                                        resolve({ values: [], newIds: {} });
                                    } else {
                                        var values = keys.map(function (key) {
                                            return {
                                                key: key,
                                                value: core_1.noUndef(_.get(state.combined, key))
                                            };
                                        });
                                        if (_auth && _auth.field) {
                                            var indices = { username: -1, password: -1 };
                                            values.forEach(function (_ref14, i) {
                                                var _ref14$key = _slicedToArray(_ref14.key, 3),
                                                    type = _ref14$key[0],
                                                    _ = _ref14$key[1],
                                                    field = _ref14$key[2];

                                                if (type === _auth.field.type) {
                                                    if (field === _auth.field.field) indices.username = i;
                                                    if (field === 'password') indices.password = i;
                                                }
                                            });
                                            if (indices.username !== -1 || indices.password !== -1) {
                                                values = [].concat(_toConsumableArray(values.filter(function (_, i) {
                                                    return i !== indices.username && i !== indices.password;
                                                })), [{
                                                    key: [_auth.field.type, values[indices.username].key[1] || values[indices.password].key[1], _auth.field.field],
                                                    value: JSON.stringify(core_1.keysToObject(['username', 'password'].filter(function (k) {
                                                        return indices[k] !== -1;
                                                    }), function (k) {
                                                        return values[indices[k]].value;
                                                    }))
                                                }]);
                                            }
                                        }
                                        commits.push({
                                            values: values,
                                            watcher: function () {
                                                var _ref16 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref15) {
                                                    var newIds = _ref15.newIds,
                                                        errors = _ref15.errors;
                                                    return regeneratorRuntime.wrap(function _callee4$(_context4) {
                                                        while (1) {
                                                            switch (_context4.prev = _context4.next) {
                                                                case 0:
                                                                    if (errors) {
                                                                        resolve(null);
                                                                    } else {
                                                                        if (_auth && newIds['$user']) delete newIds['$user'];
                                                                        state.setClient(keys.map(function (key) {
                                                                            return { key: key, value: undefined };
                                                                        }));
                                                                        resolve({
                                                                            values: keys.map(function (_ref17) {
                                                                                var _ref18 = _slicedToArray(_ref17, 3),
                                                                                    type = _ref18[0],
                                                                                    id = _ref18[1],
                                                                                    field = _ref18[2];

                                                                                return core_1.noUndef(_.get(state.combined, [type, newIds[type] && newIds[type][id] || id, field]));
                                                                            }),
                                                                            newIds: newIds
                                                                        });
                                                                    }

                                                                case 1:
                                                                case "end":
                                                                    return _context4.stop();
                                                            }
                                                        }
                                                    }, _callee4, _this2);
                                                }));

                                                function watcher(_x4) {
                                                    return _ref16.apply(this, arguments);
                                                }

                                                return watcher;
                                            }()
                                        });
                                        run();
                                    }
                                }));

                            case 1:
                            case "end":
                                return _context5.stop();
                        }
                    }
                }, _callee5, this);
            }));

            function commit(_x3) {
                return _ref13.apply(this, arguments);
            }

            return commit;
        }()
    };
}
exports.buildClient = buildClient;