"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../core");
exports.getFilterFields = function (filter) {
    if (filter[0] === 'AND' || filter[0] === 'OR') {
        return filter[1].reduce(function (res, f) {
            return [].concat(_toConsumableArray(res), _toConsumableArray(exports.getFilterFields(f)));
        }, []);
    }
    return [filter[0]];
};
function queryLayers(schema, queryDoc, userId, addIds) {
    var processRelation = function processRelation(root, field, node, path) {
        var fieldNodes = node.selectionSet.selections;
        var scalarFields = core_1.keysToObject(fieldNodes.filter(function (_ref) {
            var selectionSet = _ref.selectionSet;
            return !selectionSet;
        }).map(function (_ref2) {
            var name = _ref2.name;
            return name.value;
        }), function () {
            return true;
        });
        if (addIds) scalarFields.id = true;
        var args = core_1.parseArgs(node.arguments, userId, schema[field.type], !!root.type && core_1.fieldIs.relation(field));
        var filterFields = args.filter ? exports.getFilterFields(args.filter) : [];
        var argsState = { extra: { start: 0, end: 0 }, ids: [] };
        var getArgsState = function getArgsState(state) {
            if (state) {
                argsState.extra = { start: 0, end: 0 };
                argsState.ids = [];

                var _loop = function _loop(id) {
                    if (state.diff[field.type][id] === 1 || state.diff[field.type][id] === 0) {
                        if (filterFields.some(function (f) {
                            return state.combined[field.type][id][f] === undefined;
                        }) || core_1.runFilter(args.filter, id, state.combined[field.type][id])) {
                            argsState.extra.start += 1;
                            if (state.diff[field.type][id] === 0) {
                                argsState.extra.end += 1;
                                argsState.ids.push(id);
                            }
                        }
                    }
                    if (state.diff[field.type][id] === -1) {
                        if (!(state.server[field.type] && state.server[field.type][id]) || filterFields.some(function (f) {
                            return state.server[field.type][id][f] === undefined;
                        })) {
                            argsState.extra.end += 1;
                            argsState.ids.push(id);
                        } else if (core_1.runFilter(args.filter, id, state.server[field.type] && state.server[field.type][id])) {
                            argsState.extra.end += 1;
                        }
                    }
                };

                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    for (var _iterator = Object.keys(state.diff[field.type] || {})[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        var id = _step.value;

                        _loop(id);
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }

                argsState.extra.start = Math.min(args.start || 0, argsState.extra.start);
            }
            return argsState;
        };
        return {
            root: root,
            field: field,
            args: args,
            structuralFields: Array.from(new Set([].concat(_toConsumableArray(filterFields), _toConsumableArray((args.sort || []).map(function (_ref3) {
                var _ref4 = _slicedToArray(_ref3, 1),
                    f = _ref4[0];

                return f;
            }))))),
            scalarFields: scalarFields,
            relations: fieldNodes.filter(function (_ref5) {
                var selectionSet = _ref5.selectionSet;
                return selectionSet;
            }).map(function (node) {
                var schemaField = schema[field.type][node.name.value];
                return processRelation({ type: field.type, field: node.name.value }, schemaField, node, path + "_" + node.name.value);
            }),
            path: path,
            getArgsState: getArgsState
        };
    };
    var rootSelection = queryDoc.definitions[0].selectionSet.selections;
    return rootSelection.map(function (node) {
        return processRelation({ field: node.name.value }, { type: node.name.value, isList: true }, node, node.name.value);
    });
}
exports.default = queryLayers;