"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _templateObject = _taggedTemplateLiteral(["\n\nstart\n= _ main:or _ { return main[0]; }\n/ _ { return {}; }\n\nor\n= lhs:and _ '|' _ rhs:or2 { return [['OR', lhs.concat(rhs)]]; }\n/ and\n\nor2\n= lhs:block _ '|' _ rhs:or2 { return lhs.concat(rhs); }\n/ and\n\nand\n= lhs:block _ ',' _ rhs:and2 { return [['AND', lhs.concat(rhs)]]; }\n/ block\n\nand2\n= lhs:block _ ',' _ rhs:and2 { return lhs.concat(rhs); }\n/ block\n\nblock\n= '(' _ sentence:or _ ')' { return sentence; }\n/ statement\n\nstatement\n= f:field _ o:op _ e:expr { return [[f, o, e]]; }\n/ '!' _ f:field { return [[f, '=', 'null']]; }\n/ f:field { return [[f, '!=', 'null']]; }\n\nfield\n= ''' f:[a-z0-9-_]i+ ''' { return f.join(''); }\n/ '\"' f:[a-z0-9-_]i+ '\"' { return f.join(''); }\n/ f:[a-z0-9-_]i+ { return f.join(''); }\n\nop\n= '!=' / '<=' / '>=' / '=' / '<' / '>' { return text(); }\n\nexpr\n= ''' t:[^']* ''' { return t.join('').trim(); }\n/ '\"' t:[^\"]i* '\"' { return t.join('').trim(); }\n/ '[' t:[^]]i* ']' { return t.join('').split(',').map(function(s) { return s.trim() }); }\n/ t:[^'\",|()]* { return t.join('').trim(); }\n\n_\n= whiteSpace*\n\nwhiteSpace\n= [ \t\n\r]+\n\n"], ["\n\nstart\n= _ main:or _ { return main[0]; }\n/ _ { return {}; }\n\nor\n= lhs:and _ '|' _ rhs:or2 { return [['OR', lhs.concat(rhs)]]; }\n/ and\n\nor2\n= lhs:block _ '|' _ rhs:or2 { return lhs.concat(rhs); }\n/ and\n\nand\n= lhs:block _ ',' _ rhs:and2 { return [['AND', lhs.concat(rhs)]]; }\n/ block\n\nand2\n= lhs:block _ ',' _ rhs:and2 { return lhs.concat(rhs); }\n/ block\n\nblock\n= '(' _ sentence:or _ ')' { return sentence; }\n/ statement\n\nstatement\n= f:field _ o:op _ e:expr { return [[f, o, e]]; }\n/ '!' _ f:field { return [[f, '=', 'null']]; }\n/ f:field { return [[f, '!=', 'null']]; }\n\nfield\n= '\\'' f:[a-z0-9-_]i+ '\\'' { return f.join(''); }\n/ '\"' f:[a-z0-9-_]i+ '\"' { return f.join(''); }\n/ f:[a-z0-9-_]i+ { return f.join(''); }\n\nop\n= '!=' / '<=' / '>=' / '=' / '<' / '>' { return text(); }\n\nexpr\n= '\\'' t:[^']* '\\'' { return t.join('').trim(); }\n/ '\"' t:[^\"]i* '\"' { return t.join('').trim(); }\n/ '[' t:[^\\]]i* ']' { return t.join('').split(',').map(function(s) { return s.trim() }); }\n/ t:[^'\",|()]* { return t.join('').trim(); }\n\n_\n= whiteSpace*\n\nwhiteSpace\n= [ \\t\\n\\r]+\n\n"]);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

Object.defineProperty(exports, "__esModule", { value: true });
var peg = require("pegjs");
var core_1 = require("../core");
var parser = peg.generate(String.raw(_templateObject)).parse;
var parseValue = function parseValue(value, scalar) {
    if (value === 'null') return null;
    if (scalar === 'boolean') return { true: true, false: false }[value];
    if (scalar === 'int') return parseInt(value, 10);
    if (scalar === 'float') return parseFloat(value);
    if (scalar === 'date') {
        var parts = value.split(/^(\d\d?)\/(\d\d?)\/(\d\d(?:\d\d)?)$/).slice(1).map(parseFloat);
        if (parts.length === 0) return null;
        var dd = parts[0];
        var mm = parts[1] - 1;
        var yy = parts[2] + (parts[2] < 100 ? parts[2] < 30 ? 2000 : 1900 : 0);
        var d = new Date(yy, mm, dd);
        if (d.getDate() !== dd || d.getMonth() !== mm || d.getFullYear() !== yy) return null;
        return d;
    }
    return value;
};
var parseFilterValues = function parseFilterValues(filter, fields) {
    if (filter[0] === 'AND' || filter[0] === 'OR') {
        return [filter[0], filter[1].map(function (f) {
            return parseFilterValues(f, fields);
        })];
    }

    var _filter = _slicedToArray(filter, 3),
        fieldName = _filter[0],
        op = _filter[1],
        value = _filter[2];

    var field = fields[fieldName];
    var scalar = core_1.fieldIs.scalar(field) ? field.scalar : 'string';
    if (scalar === 'boolean' && (op === '=' || op === '!=') && value === 'null') {
        return [op === '=' ? 'OR' : 'AND', [[fieldName, op, null], [fieldName, op, false]]];
    }
    return [fieldName, op, parseValue(value, scalar)];
};
function parseArgs() {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var userId = arguments[1];
    var fields = arguments[2];
    var allowNullSort = arguments[3];

    var result = Array.isArray(args) ? core_1.keysToObject(args, function (_ref) {
        var value = _ref.value;
        return value.kind === 'IntValue' ? parseInt(value.value, 10) : value.value;
    }, function (_ref2) {
        var name = _ref2.name;
        return name.value;
    }) : args;
    if (result.filter && typeof result.filter === 'string') {
        result.filter = parseFilterValues(parser(result.filter.replace(/\$user/g, userId || '').replace(/OR/g, '|')), fields);
    }
    if (result.sort && typeof result.sort === 'string') {
        result.sort = result.sort.split(/[\s,]+/).map(function (s) {
            return [s[0] === '-' ? s.slice(1) : s, s[0] === '-' ? 'desc' : 'asc'];
        });
    }
    if (!allowNullSort) result.sort = result.sort || [];
    if (result.sort) {
        if (!result.sort.some(function (_ref3) {
            var _ref4 = _slicedToArray(_ref3, 1),
                f = _ref4[0];

            return f === 'createdat';
        })) {
            result.sort.push(['createdat', 'desc']);
        }
        if (!result.sort.some(function (_ref5) {
            var _ref6 = _slicedToArray(_ref5, 1),
                f = _ref6[0];

            return f === 'id';
        })) {
            result.sort.push(['id', 'asc']);
        }
    }
    return result;
}
exports.default = parseArgs;