"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

Object.defineProperty(exports, "__esModule", { value: true });
exports.noUndef = function (v) {
    var replacer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    return v === undefined ? replacer : v;
};
exports.undefOr = function (v) {
    var replacer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    return v === undefined ? undefined : replacer;
};
exports.isObject = function (v) {
    return Object.prototype.toString.call(v) === '[object Object]';
};
exports.mapArray = function (v, map) {
    return Array.isArray(v) ? v.map(map) : map(v);
};
exports.keysToObject = function (keys, valueMap, keyMap) {
    var valueFunc = typeof valueMap === 'function';
    return keys.reduce(function (res, k, i) {
        var newValue = valueFunc ? valueMap(k, i) : valueMap;
        return newValue === undefined ? res : Object.assign({}, res, _defineProperty({}, keyMap ? keyMap(k, i) : "" + k, newValue));
    }, {});
};
var binarySearch = function binarySearch(element, array, compareFunc) {
    var start = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
    var end = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : array.length;

    if (array.length === 0) return -1;
    var pivot = start + end >> 1;
    var c = compareFunc(element, array[pivot]);
    if (end - start <= 1) return c === 1 ? pivot : pivot - 1;
    if (c === 0) return pivot - 1;
    return c === 1 ? binarySearch(element, array, compareFunc, pivot, end) : binarySearch(element, array, compareFunc, start, pivot);
};
exports.locationOf = function (element, array, compareFunc) {
    return binarySearch(element, array, compareFunc) + 1;
};
exports.promisifyEmitter = function (emitter, listener) {
    if (listener) return emitter(listener);
    return new Promise(function (resolve) {
        var unlisten = emitter(function (value) {
            if (value !== null) {
                if (unlisten) unlisten();else setTimeout(function () {
                    return unlisten();
                });
                resolve(value);
            }
        });
    });
};
var compareValues = function compareValues(a, b) {
    if (a === b) return 0;
    if (typeof a === 'string' && typeof b === 'string') {
        return a.toLowerCase().localeCompare(b.toLowerCase());
    }
    if (a < b) return -1;
    return 1;
};
exports.createCompare = function (get) {
    var sort = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    return function (value1, value2) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
            for (var _iterator = sort[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var _ref = _step.value;

                var _ref2 = _slicedToArray(_ref, 2);

                var key = _ref2[0];
                var order = _ref2[1];

                var v1 = exports.noUndef(get(value1, key));
                var v2 = exports.noUndef(get(value2, key));
                if (v1 === null && v2 !== null) return 1;
                if (v1 !== null && v2 === null) return -1;
                var comp = compareValues(v1, v2);
                if (comp) return order === 'asc' ? comp : -comp;
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                }
            } finally {
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }

        return 0;
    };
};
exports.runFilter = function (filter, id, record) {
    if (!record) return false;
    if (!filter) return true;
    if (filter[0] === 'AND') {
        return filter[1].every(function (b) {
            return exports.runFilter(b, id, record);
        });
    } else if (filter[0] === 'OR') {
        return filter[1].some(function (b) {
            return exports.runFilter(b, id, record);
        });
    }

    var _filter = _slicedToArray(filter, 3),
        key = _filter[0],
        op = _filter[1],
        value = _filter[2];

    var v = key === 'id' ? id : exports.noUndef(record[key]);
    if (op === '=') return v === value;
    if (op === '!=') return v !== value;
    if (op === '<') return v < value;
    if (op === '<=') return v <= value;
    if (op === '>') return v > value;
    if (op === '>=') return v >= value;
    if (op === 'in') return value.includes(v);
    return false;
};